#!/usr/bin/perl

use warnings;
use strict;

#relative link to the api
use lib "../MicrobeDB/";

use FullUpdate;

my $usage = "./save_version.pl <version_id> [name]\n";

my $version_id = $ARGV[0];

unless(defined($version_id)){
    print $usage;
    exit;
}

my $name = $ARGV[1];
unless(defined($name)){
    $name = `whoami`;    
}
chomp($name);

my $up_obj = new FullUpdate( dl_directory => '/' );
my $notice =  $up_obj->save_version($version_id, $name);

if($notice){
    print "Version $version_id was saved under the name $name.\n";
}else{
    print "Version $version_id did NOT save under the name $name!\n";
}

